.\" $NetBSD: ac.8,v 1.15 2003/06/27 22:53:52 wiz Exp $
.\"
.\" Copyright (c) 1980, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\" Copyright (c) 1994 Simon J. Gerraty
.\" Copyright (c) 1994 Christopher G. Demetriou
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgements:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\"      This product includes software developed by Christopher G. Demetriou.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)ac.8	8.2 (Berkeley) 4/19/94
.\"
.Dd April 19, 1994
.Dt AC 8
.Os
.Sh NAME
.Nm ac
.Nd display connect time accounting
.Sh SYNOPSIS
.Nm
.Op Fl d | p
.Op Fl t Ar tty
.Op Fl w Ar file
.Op Ar users ...
.Sh DESCRIPTION
If the file
.Pa /var/log/wtmp
exists,
a record of individual
login and logout times are written to it by
.Xr login 1
and
.Xr init 8 ,
respectively.
The program
.Nm
examines these
records and writes the accumulated connect time for all logins to the
standard output.
.Pp
Options available:
.Bl -tag -width indentXXX
.It Fl d
Display the connect times in 24 hour chunks.
.It Fl p
Display individual user totals.
.It Fl t Ar tty
Only do accounting logins on certain ttys.  The
.Ar tty
specification can start with
.Ql \&!
to indicate not this
.Ar tty
and end with
.Ql *
to indicate all similarly named ttys.
Multiple
.Fl t
flags may be specified.
.It Fl w Ar file
Read raw connect time data from
.Ar file
instead of the default file
.Pa /var/log/wtmp .
.It Ar users ...
Display totals for the given individuals
only.
.El
.Pp
If no arguments are given,
.Nm
displays the total amount of login time for all active accounts on the
system.
.Pp
The default
.Pa wtmp
file is an infinitely increasing file
unless frequently truncated.  This is normally
done by the daily daemon scripts scheduled by
.Xr cron 8 ,
which rename and rotate the
.Pa wtmp
files before truncating them (and keep about a week's worth on hand).
No login times are collected, however, if the file does not exist.
.Pp
For example,
.Bd -literal -offset indent
ac -p -t "ttyd*" \*[Gt] modems
ac -p -t "!ttyd*" \*[Gt] other
.Ed
.Pp
allows times recorded in
.Pa modems
to be charged out at a different rate than
.Pa other .
.Pp
The
.Nm
utility exits 0 on success, and \*[Gt]0 if a fatal error occurs.
.Sh FILES
.Bl -tag -width /var/log/wtmp.[0-7] -compact
.It Pa /var/log/wtmp
connect time accounting file
.It Pa /var/log/wtmp.[0-7]
rotated files
.El
.Sh SEE ALSO
.Xr login 1 ,
.Xr utmp 5 ,
.Xr init 8 ,
.Xr sa 8
.Sh HISTORY
An
.Nm
command appeared in
.At v6 .
This version of
.Nm
was written for
.Nx 1.0
from the specification provided by various systems' manual pages.
